/* This file was generated by scramble.py. */
#line 1 "src/make.py"
#include "make.h"
#line 5
Trees * global_trees;
static void _push(void);
static void _pop(void);
static void _size(F x, F y, F z);
static void _turn(F x, F y, F z, F a);
static void _move(F x, F y, F z);
static void _orient(void);
static void _make(str name);
static void _color(F r, F g, F b, F a);
#line 7
static void _push(void) {
#line 7
    G.stack [G.st++] = G.m;
}
#line 8
static void _pop(void) {
#line 8
    G.m = G.stack [--G.st];
}
#line 9
static void _size(F x, F y, F z) {
#line 9
    G.m = land_4x4_matrix_mul(G.m, land_4x4_matrix_scale(x, y, z));
}
#line 10
static void _turn(F x, F y, F z, F a) {
#line 10
    G.m = land_4x4_matrix_mul(G.m, land_4x4_matrix_rotate(x, y, z, pi * a));
}
#line 11
static void _move(F x, F y, F z) {
#line 11
    G.m = land_4x4_matrix_mul(G.m, land_4x4_matrix_translate(x, y, z));
}
#line 12
static void _orient(void) {
#line 12
    G.m = land_4x4_matrix_identity();
}
#line 13
static void _make(str name) {
#line 13
    mesh_add(G.mesh, name, G.color, G.m);
}
#line 14
static void _color(F r, F g, F b, F a) {
#line 14
    G.color = land_color_rgba(r, g, b, a);
}
Mesh* make_kind(Trees * trees, str name) {
    global_trees = trees;
    Mesh * m = land_hash_get(trees->kinds_by_name, name);
    if (m) {
#line 19
        return m;
    }
    int anims = 1;
#line 23
    if (land_equals(name, "oak") || land_equals(name, "fir") || land_equals(name, "eucalypt")) {
        anims = 19;
    }
#line 25
    if (land_equals(name, "fire") || land_equals(name, "smoke")) {
        anims = 10;
    }
#line 27
    if (land_equals(name, "beetle")) {
        anims = 8;
    }
    for (int i = 0; i < anims; i += 1) {
        G.mesh = mesh_make(name);
        if (! m) {
            m = G.mesh;
        }
        mesh_add_anim(m, G.mesh);
        _orient();
#line 38
        if (land_equals(name, "oak")) {
            float fade = 1 - i / 19.0;
            for (int ir = 0; ir < 6; ir += 1) {
                _push();
                _color(0.5 * fade, 0.7 * fade, 0, 1);
                _move(0, 0, 20 + ir * 3);
                _turn(0, 0, 1, 0.4 * ir);
                if (ir < 5) {
                    _turn(0, 1, 0, 0.25);
                }
#line 47
                _size(15 * fade, 15 * fade, 20);
                _move(0, 0, 1);
                _make("ball");
                _pop();
            }
            _push();
            _color(0.4 * fade, 0.2 * fade, 0, 1);
            _size(4, 4, 15);
            _move(0, 0, 1);
            _make("cylinder");
            _pop();
        }
        if (land_equals(name, "fir")) {
            float fade = 1 - i / 19.0;
            for (int ir = 0; ir < 6; ir += 1) {
                _push();
                _color(0, 0.6 * fade, 0.3 * fade, 1);
                _move(0, 0, 20 + ir * 5);
                float s = 20 - ir * 2;
                _turn(0, 0, 1, ir / 3.0);
                _turn(0, 1, 0, i / 19.0 * 0.5);
                _size(s * fade, s * fade, 10);
                _move(0, 0, 1);
                _make("cone");
                _pop();
            }
            _push();
            _color(0.4 * fade, 0.2 * fade, 0, 1);
            _size(3, 3, 20);
            _move(0, 0, 1);
            _make("cone");
            _pop();
        }
        if (land_equals(name, "beetle")) {
            _push();
            _color(1, 1, 0, 1);
            _move(0, 0, 1);
            _size(3, 5, 2);
            _move(0, 0, 1);
            _make("ball");
            _pop();
#line 89
            float la = (i - 2) / 2.0;
            if (i > 4) {
#line 90
                la = (8 - i - 2) / 2.0;
            }
#line 91
            for (int lx = 0; lx < 2; lx += 1) {
                for (int ly = 0; ly < 3; ly += 1) {
                    _push();
                    _move(- 1 + lx * 2, ly, 0);
                    _turn(1, 0, 0, la / 4);
                    _move(0, 0, - 1);
                    _make("cylinder");
                    _pop();
                }
            }
        }
#line 100
        if (land_equals(name, "eucalypt")) {
            float fade = 1 - i / 19.0;
            for (int ir = 0; ir < 3; ir += 1) {
                _push();
                _color(0.6 * fade, 0.7 * fade, 0.5 * fade, 1);
                _move(0, 0, 50 + ir * 10);
                _turn(0, 0, 1, ir * 2.0 / 3);
                _size(30, 20 * fade, 2);
                _move(0.7, 0, 1);
                _make("cone");
                _pop();
            }
            _push();
            _color(1 * fade, 0.6 * fade, 0.7 * fade, 1);
            _size(3, 3, 40);
            _move(0, 0, 1);
            _make("cone");
            _pop();
        }
        if (land_equals(name, "fire")) {
            _push();
            float s = land_rnd(3, 10);
            _color(1, land_rnd(0, 1), land_rnd(0, 0.2), 1);
            _size(s, s, s);
            _make("ball");
            _pop();
        }
        if (land_equals(name, "smoke")) {
            _push();
            float s = land_rnd(5, 13);
            float a = land_rnd(0.1, 1);
            float b = land_rnd(0, 1);
            _color(a * b, a * b, a * b, a);
            _size(s, s, s);
            _make("ball");
            _pop();
        }
    }
#line 137
    land_hash_insert(trees->kinds_by_name, name, m);
    return m;
}
/* This file was generated by scramble.py. */
