/* This file was generated by scramble.py. */
#line 1 "src/trees.py"
#include "trees.h"
#line 59
static bool flag;
#line 61
Trees* trees_new(void) {
    Trees * self;
    land_alloc(self);
    self->trees = land_array_new();
    self->particles = land_array_new();
    land_array_add(self->trees, NULL);
    self->kinds_by_name = land_hash_new();
#line 69
    for (int i = 0; i < PC; i += 1) {
        Tree * p;
        land_alloc(p);
        land_array_add(self->particles, p);
    }
#line 73
    return self;
}
void trees_clear(Trees * self) {
    {
#line 76
        LandArrayIterator __iter0__ = LandArrayIterator_first(self->trees);
#line 76
        for (Tree * tree = LandArrayIterator_item(self->trees, &__iter0__); LandArrayIterator_next(self->trees, &__iter0__); tree = LandArrayIterator_item(self->trees, &__iter0__)) {
            land_free(tree);
        }
    }
#line 78
    land_array_clear(self->trees);
    land_array_add(self->trees, NULL);
#line 81
    {
#line 81
        LandArrayIterator __iter0__ = LandArrayIterator_first(self->particles);
#line 81
        for (Tree * tree = LandArrayIterator_item(self->particles, &__iter0__); LandArrayIterator_next(self->particles, &__iter0__); tree = LandArrayIterator_item(self->particles, &__iter0__)) {
            tree->alive = 0;
        }
    }
#line 84
    self->lost = 0;
}
Tree* trees_make(Trees * trees, str name, float x, float y, float z) {
    Tree * tree;
    land_alloc(tree);
    tree->mesh = make_kind(trees, name);
    tree->alive = 1;
    if (land_equals(name, "beetle")) {
        tree->angle = atan2(x, - y);
        tree->beetle = 1;
    }
#line 93
    else {
#line 95
        tree->angle = land_rnd(- pi / 4, pi / 4);
        if (land_equals(name, "eucalypt")) {
            tree->invasive = 1;
        }
    }
    tree->pos = land_4x4_matrix_mul(land_4x4_matrix_translate(x, y, z), land_4x4_matrix_rotate(0, 0, 1, tree->angle));
    land_array_add(trees->trees, tree);
    return tree;
}
void trees_particle(Trees * trees, str kind, float x, float y, float z) {
    Tree * tree = land_array_get_nth(trees->particles, trees->particle_counter);
    trees->particle_counter++;
    trees->particle_counter %= PC;
    tree->mesh = make_kind(trees, kind);
    tree->pos = land_4x4_matrix_translate(x, y, z);
    tree->v = land_vector(0, 0, 0);
    tree->whirl = 0;
    tree->burning = 0;
    tree->alive = 1;
    tree->frame = land_rand(0, land_array_count(tree->mesh->frames) - 1);
#line 116
    if (land_starts_with(kind, "fire")) {
        tree->v.z = 0.7;
    }
#line 118
    if (land_starts_with(kind, "smoke")) {
        tree->v.x = land_rnd(- 0.2, 0.2);
        tree->v.y = land_rnd(- 0.2, 0.2);
        tree->v.z = 0.5;
    }
}
#line 123
void trees_draw(Trees * trees) {
    {
#line 124
        LandArrayIterator __iter0__ = LandArrayIterator_first(trees->trees);
#line 124
        for (Tree * tree = LandArrayIterator_item(trees->trees, &__iter0__); LandArrayIterator_next(trees->trees, &__iter0__); tree = LandArrayIterator_item(trees->trees, &__iter0__)) {
            if (! tree) {
#line 125
                continue;
            }
#line 126
            Mesh * mesh = land_array_get_nth(tree->mesh->frames, tree->frame);
            mesh_draw(mesh, tree->pos);
        }
    }
#line 128
    {
#line 128
        LandArrayIterator __iter0__ = LandArrayIterator_first(trees->particles);
#line 128
        for (Tree * tree = LandArrayIterator_item(trees->particles, &__iter0__); LandArrayIterator_next(trees->particles, &__iter0__); tree = LandArrayIterator_item(trees->particles, &__iter0__)) {
            if (! tree->alive) {
#line 129
                continue;
            }
#line 130
            Mesh * mesh = land_array_get_nth(tree->mesh->frames, tree->frame);
            mesh_draw(mesh, tree->pos);
        }
    }
}
#line 134
void trees_callback(Trees * trees, float x, float y, float radius, void(* cb)(Trees * trees, Tree *, float, float)) {
    {
#line 135
        LandArrayIterator __iter0__ = LandArrayIterator_first(trees->trees);
#line 135
        for (Tree * tree = LandArrayIterator_item(trees->trees, &__iter0__); LandArrayIterator_next(trees->trees, &__iter0__); tree = LandArrayIterator_item(trees->trees, &__iter0__)) {
            if (! tree) {
#line 136
                continue;
            }
#line 137
            if (! tree->alive) {
#line 137
                continue;
            }
#line 138
            float dx = tree->pos.v [3] - x;
            float dy = tree->pos.v [7] - y;
            if (dx * dx + dy * dy < radius * radius) {
                cb(trees, tree, dx, dy);
            }
        }
    }
}
#line 144
void trees_callback_square(Trees * trees, float x, float y, float radius, void(* cb)(Trees * trees, Tree *, float, float)) {
    {
#line 145
        LandArrayIterator __iter0__ = LandArrayIterator_first(trees->trees);
#line 145
        for (Tree * tree = LandArrayIterator_item(trees->trees, &__iter0__); LandArrayIterator_next(trees->trees, &__iter0__); tree = LandArrayIterator_item(trees->trees, &__iter0__)) {
            if (! tree) {
#line 146
                continue;
            }
#line 147
            if (! tree->alive) {
#line 147
                continue;
            }
#line 148
            float dx = tree->pos.v [3] - x;
            float dy = tree->pos.v [7] - y;
            if (dx > - radius && dx < radius && dy > - radius && dy < radius) {
                cb(trees, tree, dx, dy);
            }
        }
    }
}
#line 153
void tree_whirl(Trees * trees, Tree * tree, float dx, float dy) {
    if (tree->whirl) {
#line 154
        return ;
    }
#line 155
    if (tree->beetle) {
        land_sound_play(game->frog, 1, 0, 1);
    }
#line 156
    else {
#line 158
        land_sound_play(game->tree, 1, 0, 1);
    }
#line 159
    tree->whirl = 1;
    tree->v = land_vector_normalize(land_vector(dx, dy, 1));
    tree->v.x *= 5;
    tree->v.y *= 5;
    tree->v.z = 20;
#line 165
    tree->rot = land_vector_normalize(land_vector_cross(land_vector(0, 0, 1), land_vector(dx, dy, 0)));
}
void tree_burn(Trees * trees, Tree * tree, float dx, float dy) {
    if (tree->sink) {
#line 168
        return ;
    }
#line 169
    if (tree->rising && ! tree->invasive) {
#line 169
        return ;
    }
#line 170
    if (tree->frame == 18 || tree->burning || tree->sick > 18) {
#line 170
        return ;
    }
#line 171
    tree->burning = 140;
}
void tree_spread_fire(Trees * trees, Tree * tree, float dx, float dy) {
    if (tree->sink) {
#line 174
        return ;
    }
#line 175
    if (tree->rising) {
#line 175
        return ;
    }
#line 176
    if (tree->frame == 18 || tree->burning || tree->sick > 18) {
#line 176
        return ;
    }
#line 177
    tree->burning = 140;
}
void tree_sink(Trees * trees, Tree * tree, float dx, float dy) {
    tree->sink = 1;
    tree->burning = 0;
}
void tree_water(Trees * trees, Tree * tree, float dx, float dy) {
    if (tree->sink) {
#line 184
        return ;
    }
#line 185
    tree->water++;
    if (tree->water > 2) {
        tree->burning = 0;
        if (tree->beetle) {
            tree->sink = 1;
            land_sound_play(game->frog, 1, 0, 1);
        }
    }
#line 191
    if (tree->water > 6) {
        tree->sink = 1;
        land_sound_play(game->tree, 1, 0, 1);
    }
}
#line 195
void tree_sicken(Trees * trees, Tree * tree, float dx, float dy) {
    if (tree->invasive) {
#line 196
        return ;
    }
    if (tree->beetle) {
#line 198
        return ;
    }
#line 199
    flag = 1;
    tree->sick++;
    if (tree->frame < 18) {
        tree->frame++;
    }
}
#line 204
void tree_blight(Trees * trees, Tree * tree, float dx, float dy) {
    if (tree->invasive) {
#line 205
        return ;
    }
    if (tree->beetle) {
#line 207
        return ;
    }
#line 208
    tree->blighted = 1;
    tree_sicken(trees, tree, dx, dy);
}
void tree_infest(Trees * trees, Tree * tree, float dx, float dy) {
    if (tree->sink) {
#line 212
        return ;
    }
#line 213
    if (tree->sick) {
#line 213
        return ;
    }
#line 214
    if (tree->infested) {
        if (trees->hungry < 50) {
#line 215
            return ;
        }
    }
#line 217
    if (land_equals(tree->mesh->name, "oak")) {
        trees->found = tree;
    }
}
#line 220
void tree_flag(Trees * trees, Tree * tree, float dx, float dy) {
    flag = 1;
}
void trees_dance(Trees * trees) {
    {
#line 224
        LandArrayIterator __iter0__ = LandArrayIterator_first(trees->trees);
#line 224
        for (Tree * tree = LandArrayIterator_item(trees->trees, &__iter0__); LandArrayIterator_next(trees->trees, &__iter0__); tree = LandArrayIterator_item(trees->trees, &__iter0__)) {
            if (! tree) {
                continue;
            }
#line 227
            if (! tree->dancing) {
                tree->dance = tree->pos;
                tree->dancing = 1;
            }
#line 230
            float x = tree->dance.v [3];
            float y = tree->dance.v [7];
            float z = tree->dance.v [11];
            int t = land_get_ticks();
            int t2 = t % 120;
            z += (sin((t % 30) / 30.0 * pi * 2) + 1) * 10;
#line 238
            tree->pos = land_4x4_matrix_mul(land_4x4_matrix_translate(x, y, z), land_4x4_matrix_rotate(0, 1, 0, sin(t2 / 120.0 * pi * 2) / 2));
        }
    }
#line 240
    {
#line 240
        LandArrayIterator __iter0__ = LandArrayIterator_first(trees->particles);
#line 240
        for (Tree * tree = LandArrayIterator_item(trees->particles, &__iter0__); LandArrayIterator_next(trees->particles, &__iter0__); tree = LandArrayIterator_item(trees->particles, &__iter0__)) {
            if (! tree->alive) {
#line 241
                continue;
            }
#line 242
            if (! tree->dancing) {
                tree->dance = tree->pos;
                tree->dancing = 1;
            }
#line 245
            int t = land_get_ticks();
            int t2 = t % 120;
#line 248
            tree->pos = land_4x4_matrix_mul(land_4x4_matrix_rotate(0, 0, 1, t2 / 120.0 * pi * 2), tree->dance);
        }
    }
}
#line 250
void trees_tick(Trees * trees) {
    {
#line 251
        LandArrayIterator __iter0__ = LandArrayIterator_first(trees->trees);
#line 251
        for (Tree * tree = LandArrayIterator_item(trees->trees, &__iter0__); LandArrayIterator_next(trees->trees, &__iter0__); tree = LandArrayIterator_item(trees->trees, &__iter0__)) {
            if (! tree) {
                continue;
            }
#line 254
            if (tree->dancing) {
                tree->pos = tree->dance;
                tree->dancing = 0;
            }
#line 257
            float x = tree->pos.v [3];
            float y = tree->pos.v [7];
            float z = tree->pos.v [11];
            if (tree->burning) {
                tree->burning--;
                if (tree->burning == 0) {
                    if (tree->beetle) {
                        tree->sink = 1;
                        land_sound_play(game->frog, 1, 0, 1);
                    }
#line 265
                    else {
#line 267
                        trees->lost++;
                        tree->frame = 18;
                        tree->sick = 19;
                    }
                    trees_callback(trees, tree->pos.v [3], tree->pos.v [7], 100, tree_spread_fire);
                    continue;
                }
                if (! tree->beetle) {
                    int wf = 18 * (140 - tree->burning) / 140;
                    if (wf > tree->frame) {
                        tree->frame = wf;
                        tree->sick = wf;
                    }
                }
#line 280
                int f = land_rand(0, 20);
                if (f < 10) {
#line 284
                    trees_particle(trees, f * 10 < tree->burning ? "fire" : "smoke", x + land_rnd(- 20, 20), y + land_rnd(- 20, 20), z + land_rnd(0, 20));
                }
            }
#line 285
            if (tree->sink) {
                tree->pos.v [11] -= 0.5;
                if (tree->pos.v [11] < - 100) {
                    if (tree->sick <= 18 && ! tree->beetle) {
                        trees->lost++;
                    }
#line 290
                    tree->alive = 0;
                }
            }
#line 291
            if (tree->rising) {
                z += 0.5;
                float az = world_get_altitude(game->world, x, y);
                float s = 1 - (az - z) / 100;
                if (s < 0.1) {
#line 295
                    s = 0.1;
                }
#line 299
                tree->pos = land_4x4_matrix_mul(land_4x4_matrix_translate(x, y, z), land_4x4_matrix_mul(land_4x4_matrix_scale(s, s, s), land_4x4_matrix_rotate(0, 0, 1, tree->angle)));
                if (z >= az) {
                    tree->rising = 0;
                }
            }
#line 303
            if (tree->whirl) {
                x += tree->v.x;
                y += tree->v.y;
                z += tree->v.z;
                tree->pos.v [3] = 0;
                tree->pos.v [7] = 0;
                tree->pos.v [11] = 0;
                tree->v.x *= 0.99;
                tree->v.y *= 0.99;
                tree->v.z -= 1;
#line 314
                tree->pos = land_4x4_matrix_mul(land_4x4_matrix_rotate(tree->rot.x, tree->rot.y, tree->rot.z, 0.1), tree->pos);
                tree->pos.v [3] = x;
                tree->pos.v [7] = y;
                tree->pos.v [11] = z;
                if (tree->pos.v [11] < - 100) {
                    tree->whirl = 0;
                    tree->alive = 0;
                    if (! tree->beetle) {
#line 321
                        trees->lost++;
                    }
                }
            }
#line 323
            if (tree->beetle && ! tree->sink && ! tree->rising) {
                if (tree->rest) {
                    tree->rest--;
                    continue;
                }
#line 327
                tree->frame = (land_get_ticks() / 4) % 8;
                LandVector p = land_4x4_matrix_get_position(& tree->pos);
                LandVector b = land_4x4_matrix_get_up(& tree->pos);
                if (tree->target) {
                    Tree * tt = tree->target;
                    if (! tt->alive || tt->sink || tt->sick > 18) {
                        tt->infested = 0;
                        tree->target = NULL;
                        tree->pregnant = 1;
                        continue;
                    }
#line 337
                    LandVector tp = land_4x4_matrix_get_position(& tt->pos);
                    LandVector towards = land_vector_sub(tp, p);
                    if (land_vector_norm(towards) < 20) {
                        tree_sicken(trees, tt, 0, 0);
                        tree->rest = 30;
                    }
#line 342
                    towards = land_vector_normalize(towards);
                    LandFloat di = land_vector_dot(b, towards);
                    LandFloat ci = land_vector_cross (b, towards).z;
                    if (di > 0.01) {
                        di = 0;
                        if (ci > 0.01) {
#line 347
                            di = 0.02;
                        }
#line 348
                        if (ci < - 0.01) {
#line 348
                            di = - 0.02;
                        }
                    }
#line 349
                    else if (di < - 0.01) {
                        di = (land_rnd(0, 1) - 1) * 2 * 0.02;
                    }
#line 350
                    else {
                        di = 0;
                    }
#line 352
                    tree->pos.v [3] = 0;
                    tree->pos.v [7] = 0;
                    tree->pos.v [11] = 0;
                    tree->pos = mul(land_4x4_matrix_rotate(0, 0, 1, di), tree->pos);
                    tree->pos.v [3] = p.x;
                    tree->pos.v [7] = p.y;
                    tree->pos.v [11] = p.z;
                }
#line 358
                else {
#line 360
                    if (p.x < - 440 || p.y < - 440 || p.x > 440 || p.y > 440) {
                        float tx = p.x - land_rnd(- 100, 100);
                        float ty = p.y - land_rnd(- 100, 100);
#line 364
                        tree->pos = mul(tra(p.x, p.y, p.z), land_4x4_matrix_rotate(0, 0, 1, atan2(tx, - ty)));
                    }
                }
#line 365
                if (tree->burning) {
                    b.x *= 0.3;
                    b.y *= 0.3;
                }
                tree->pos = mul(tra(b.x, b.y, world_get_altitude(game->world, p.x, p.y) - p.z), tree->pos);
            }
        }
    }
#line 371
    int n = land_array_count(trees->trees);
    int per_second = 1 + n / 60;
    for (int ri = 0; ri < per_second; ri += 1) {
        n = land_array_count(trees->trees);
        if (n < 2) {
#line 375
            break;
        }
#line 376
        int r = land_rand(1, n - 1);
        Tree * rtree = land_array_get_nth(trees->trees, r);
        float x = rtree->pos.v [3];
        float y = rtree->pos.v [7];
#line 381
        if (rtree->sink) {
            continue;
        }
#line 383
        if (rtree->rising) {
            continue;
        }
        if (rtree->sick) {
            if (rtree->sick > 18) {
                if (! rtree->sink && rtree->blighted) {
                    tree_sink(trees, rtree, 0, 0);
                    Tree * t = trees_make(trees, "eucalypt", x, y, - 99);
                    t->rising = 1;
                }
            }
#line 391
            else {
#line 393
                if (land_rand(0, 4) == 0) {
                    rtree->sick--;
                    rtree->frame--;
                }
            }
        }
#line 396
        else if (land_equals(rtree->mesh->name, "eucalypt")) {
            flag = 0;
            trees_callback(trees, x, y, 70, tree_blight);
            if (! flag) {
                x += land_rnd(- 60, 60);
                y += land_rnd(- 60, 60);
                if (x < - 480 || y < - 480 || x > 480 || y > 480) {
#line 402
                    ;
                }
#line 402
                else {
#line 405
                    flag = 0;
                    trees_callback(trees, x, y, 50, tree_flag);
                    if (! flag) {
                        Tree * t = trees_make(trees, "eucalypt", x, y, - 99);
                        t->rising = 1;
                    }
                }
            }
        }
#line 410
        else if (land_equals(rtree->mesh->name, "beetle")) {
            if (! rtree->target) {
                if (rtree->pregnant) {
                    rtree->pregnant = 0;
                    LandVector p = land_4x4_matrix_get_position(& rtree->pos);
                    Tree * clone = trees_make(trees, "beetle", p.x, p.y, p.z);
                    clone->beetle = 1;
                }
#line 417
                trees->found = NULL;
                trees->hungry = rtree->hungry;
                trees_callback(trees, x, y, 200, tree_infest);
                if (trees->found) {
                    rtree->hungry = 0;
                    rtree->target = trees->found;
                    trees->found->infested = 1;
                }
#line 423
                else {
#line 425
                    rtree->hungry++;
                }
            }
        }
    }
    // count
#line 428
    trees->fires = 0;
    trees->healthy = 0;
    trees->beetles = 0;
    trees->invasives = 0;
    trees->hidden = 0;
    trees->burning = 0;
    for (int i = 1; i < n; i += 1) {
        Tree * t = land_array_get_nth(trees->trees, i);
        if (t->burning && ! t->beetle) {
            trees->burning++;
        }
        if (land_equals(t->mesh->name, "oak") || land_equals(t->mesh->name, "fir")) {
            if (! t->sick && ! t->burning && ! t->rising) {
                trees->healthy++;
            }
#line 442
            if (t->burning) {
                trees->fires++;
            }
        }
#line 444
        if (t->beetle) {
            if (t->rising) {
#line 445
                trees->hidden++;
            }
#line 445
            else {
                trees->beetles++;
            }
        }
#line 447
        if (t->invasive) {
            if (t->rising) {
#line 448
                trees->hidden++;
            }
#line 449
            else if (t->sick <= 18) {
                trees->invasives++;
            }
        }
    }
    // prune dead trees (actually, only the first one)
#line 453
    for (int i = 1; i < n; i += 1) {
        Tree * dtree = land_array_get_nth(trees->trees, i);
        if (! dtree->alive) {
            Tree * t = land_array_remove(trees->trees, i);
#line 458
            if (land_equals(t->mesh->name, "oak") || land_equals(t->mesh->name, "fir")) {
            }
#line 459
            land_free(t);
            break;
        }
    }
#line 462
    {
#line 462
        LandArrayIterator __iter0__ = LandArrayIterator_first(trees->particles);
#line 462
        for (Tree * tree = LandArrayIterator_item(trees->particles, &__iter0__); LandArrayIterator_next(trees->particles, &__iter0__); tree = LandArrayIterator_item(trees->particles, &__iter0__)) {
            if (! tree->alive) {
#line 463
                continue;
            }
#line 464
            if (tree->dancing) {
                tree->pos = tree->dance;
                tree->dancing = 0;
            }
#line 467
            tree->pos.v [3] += tree->v.x;
            tree->pos.v [7] += tree->v.y;
            tree->pos.v [11] += tree->v.z;
            if (tree->pos.v [11] > 200) {
#line 470
                tree->alive = 0;
            }
        }
    }
}
/* This file was generated by scramble.py. */
